module Redoxed
  require_relative 'cli'

  begin
    require 'net/scp'
  rescue LoadError
    raise RedoxedError, 'net/scp not found: sudo gem install net-scp'
  end

  class SCP < Input
    include Input::CLI

    def connect(node)
      @node = node
      @node.model.cfg['scp'].each { |cb| instance_exec(&cb) }
      @log = File.open(Redoxed::Config::Log + "/#{@node.ip}-scp", 'w') if Redoxed.config.input.debug?
    end

    def cmd(file)
      Redoxed.logger.debug "SCP: #{file} @ #{@node.name}"

      Net::SCP::download!(@node.ip, @node.auth[:username], file, nil, :ssh => { :password => @node.auth[:password], :port => (vars(:ssh_port) || 22).to_i })
    end

    # meh not sure if this is the best way, but perhaps better than not implementing send
    def send(my_proc)
      my_proc.call
    end

    def output
      ""
    end

    private

    def disconnect
    # rescue Errno::ECONNRESET, IOError
    ensure
      @log.close if Redoxed.config.input.debug?
    end
  end
end
