class MICROSENS < Redoxed::Model
# Selfmade Microsens model
  prompt /(^\r|\e\[(\d+)m)?([\w\s.-]+[#>])(\e\[(\d+)m)?/

  # replace next line control sequence with a new line
  expect /(\e\[1M\e\[\??\d+(;\d+)*[A-Za-z]\e\[1L)|(\eE)/ do |data, re|
    data.gsub re, "\n"
  end

  # replace all used vt100 control sequences
  expect /\e\[\??\d+(;\d+)*[A-Za-z]/ do |data, re|
    data.gsub re, ''
  end

  cmd :all do |cfg|
    cfg = cfg.gsub /^\r/, ''
    cfg.gsub! /\e\[\??\d+(;\d+)*[A-Za-z]/, ''
  end

  cmd :secret do |cfg|
    cfg.gsub! /^(get community string \s+:).*/, '\\1 <secret hidden>'
    cfg.gsub! /^(set community string \s+:).*/, '\\1 <secret hidden>'
    cfg
  end

  cmd 'show config' do |cfg|
    cfg
  end

  cmd 'show log' do |cfg|
    cfg
  end

  cmd 'show port config' do |cfg|
    cfg
  end

  cmd 'show port alias' do |cfg|
    cfg
  end

  cmd 'show port power' do |cfg|
    cfg.gsub! /(Total Input Power\s+:\s)\d+.*/, '\\1 <stripped>'
    cfg.gsub! /(Switch Supply Power\s+:\s)\d+.*/, '\\1 <stripped>'
    cfg.gsub! /(Available PoE Power\s+:\s)\d+.*/, '\\1 <stripped>'
    cfg.gsub! /(Current PoE Power\s+:\s)\d+.*/, '\\1 <stripped>'
    cfg.gsub! /(\d+)\.(\d)/, '\\1'
    cfg.gsub! /(^\s*[0-9]+\s+(\(\w+\)\s+)?\w+\s+\w+\s+)(.*)/, '\\1<stripped>'
    cfg
  end

  cmd 'show prio' do |cfg|
    cfg
  end

  cmd 'show snmp' do |cfg|
    cfg
  end

  cmd 'show trap' do |cfg|
    cfg
  end

  cmd 'show ui' do |cfg|
    cfg
  end

  cmd 'show vlan' do |cfg|
   cfg
  end

  cmd 'show igmp config' do |cfg|
   cfg
  end

  cfg :telnet do
    password /Password:/
    pre_logout 'quit'
  end
end
